--[[ Upgrade control v1.0 by Kiffer-Opa
	This is a very simple but yet useful script to control certain upgrades
	of buildings. You are able to disable and enable all possible building
	upgrades in CS2D. By default, this script does not change the gameplay in
	ANY way. To make the script useful, you MUST configure it first. See
	the file upgradecontrolconfig.lua for further instructions.
]]

-- ALL COMMENTS AFTER THIS LINE ARE CODE SPECIFIC --

-- set up tables
if upgradecontrol == nil then upgradecontrol = {} end
upgradecontrol.settings = {}
upgradecontrol.upgrades = {}

-- load configuration (enabled/disabled upgrades and other settings)
dofile("sys/lua/upgradecontrolconfig.lua")


function upgradecontrol.objectupgrade(objectID,playerID,progress,total)
	-- initializian variable
	local objecttype = object(objectID,"type")
	
	-- is upgrade disabled?
	if(upgradecontrol.upgrades[objecttype]==false) then
		-- we land here if upgrade is disabled
		
		-- show warning message (if enabled in settings)
		if(upgradecontrol.settings.message==true) then
			parse('sv_msg2 '..playerID..' "255000000'..upgradecontrol.settings.messagetext..'@C"')
		end
		-- don't upgrade
		return 1
			
	else
		--[[ we land in this branch also if the upgrade setting in the
		     table is nil]]
		     
		-- upgrade
		return 0
	end
end

-- Call the function above each time a player tries to upgrade a building
addhook("objectupgrade","upgradecontrol.objectupgrade")
